;(function() {
        if (window.FRWebJSBridge) {
            return;
        }

        //WebJSBridge.alert("" + new Date().getTime());

        var _readyMessageIframe,
            _sendMessageQueue = [],
            _receiveMessageQueue = [],
            _callback_count = 1000,
            _callback_map = {},
            _event_hook_map = {},
            _session_data = {},
            _MESSAGE_SEPERATOR = '__frmsg_sep__',
            _CUSTOM_PROTOCOL_SCHEME = 'frweb',
            _MESSAGE_TYPE = '__msg_type',
            _CALLBACK_ID = '__callback_id',
            _EVENT_ID = '__event_id',
            _QUEUE_HAS_MESSAGE = 'dispatch_message/',
            _setResultIframe;/* 用于替代addJavascriptInterface的替代方案，返回值通过修改该iframe src实现 */

        var _event_hook_map_for3rd = {};
        
        var _isUseMd5 = 'isUseMd5_check';

        var _handleMessageIdentifier = _handleMessageFromFRWeb;
        var _fetchQueueIdentifier = _fetchQueue;
        //var _logIdentifier = _log;
        //var _envIdentifier = _env;
        var _onfor3rdIdentifier = _onfor3rd;
        var _callIdentifier = _call;

        function _createQueueReadyIframe(doc) {
            /* _setResultIframe 的初始化 */
            _setResultIframe = doc.createElement('iframe');
            _setResultIframe.id = '__FRWebJSBridgeIframe_SetResult';
            _setResultIframe.style.display = 'none';
            doc.documentElement.appendChild(_setResultIframe);

            _readyMessageIframe = doc.createElement('iframe');
            _readyMessageIframe.id = '__FRWebJSBridgeIframe';
            _readyMessageIframe.style.display = 'none';
            doc.documentElement.appendChild(_readyMessageIframe);

            return _readyMessageIframe;
        }

        /* 将消息添加到发送队列，iframe的准备队列为frweb://dispatch_message/ */
        function _sendMessage(message) {
            _sendMessageQueue.push(message);
            if (_readyMessageIframe) {
                 if (window.FRWebJSBridge._isBridgeByIframe) {
                     _readyMessageIframe.src = _CUSTOM_PROTOCOL_SCHEME + '://' + _QUEUE_HAS_MESSAGE;
                 } else {
                    console.log(_CUSTOM_PROTOCOL_SCHEME + '://' + _QUEUE_HAS_MESSAGE);
                 }
            }
        };

        /* 取出队列中的消息，并清空接收队列 */
        function _fetchQueue() {
            var curFuncIdentifier = __FRWebJSBridge._fetchQueue;
            if (curFuncIdentifier !== _fetchQueueIdentifier) {
                return '';
            }

            var messageQueueString = JSON.stringify(_sendMessageQueue);

            if (_isUseMd5 === 'yes') {
            }

            _sendMessageQueue = [];

            //console.log("native fetchQueue from webview:" + messageQueueString);

            _setResultValue('SCENE_FETCHQUEUE', messageQueueString);

            //why? show the return result in webview
            //return messageQueueString;
        }

        /* Native 向 Web 传递消息 */
        function _handleMessageFromFRWeb(message) {
            var curFuncIdentifier = __FRWebJSBridge._handleMessageFromFRWeb;
            if (curFuncIdentifier !== _handleMessageIdentifier) {
                return '{}';
            }

            var ret;
            var msgWrap;
            if (_isUseMd5 === 'yes') {
                // TODO:
                msgWrap = message;
            } else {
                msgWrap = message;
            }

            var __params = msgWrap['__params'];
            //console.log(__params);
            //console.log(typeof __params);
            if (__params == undefined) {
                __params = {};
            } else if (typeof __params == 'string') {
                __params = JSON.parse(__params);
            }

            //console.log(__params);
            //console.log(__params);
            
            switch (msgWrap[_MESSAGE_TYPE]) {

                case 'callback':
                    {
                    //console.log("***************>>>>>>>>>>>>>>>");
                    //console.log(_callback_map);
                    //console.log(msgWrap[_CALLBACK_ID]);
                    //console.log(typeof _callback_map[msgWrap[_CALLBACK_ID]]);
                    //console.log("***************>>>>>>>>>>>>>>>");

                        if (typeof msgWrap[_CALLBACK_ID] === 'string' && typeof _callback_map[msgWrap[_CALLBACK_ID]] === 'function') {
                            var ret = _callback_map[msgWrap[_CALLBACK_ID]](msgWrap['__params']);
                            //delete _callback_map[msgWrap[_CALLBACK_ID]]; // can only call once
                            _callback_map[msgWrap[_CALLBACK_ID]] = undefined;
                            _setResultValue('SCENE_HANDLEMSGFROMFRWEB', JSON.stringify(ret));
                            return JSON.stringify(ret);
                        }
                        _setResultValue('SCENE_HANDLEMSGFROMFRWEB', JSON.stringify({'__err_code':'cb404'}));
                        return JSON.stringify({'__err_code':'cb404'});
                    }
                    break;

                case 'event':
                    {
                        if (typeof msgWrap[_EVENT_ID] === 'string' ) {
                            /**
                           if (typeof _event_hook_map[msgWrap[_EVENT_ID]] === 'function') {;
                               var ret = _event_hook_map[msgWrap[_EVENT_ID]](msgWrap['__params']);
                               _setResultValue('SCENE_HANDLEMSGFROMFRWEB', JSON.stringify(ret));
                               return JSON.stringify(ret);
                           }
                            */
                            if (typeof _event_hook_map_for3rd[msgWrap[_EVENT_ID]] === 'function') {
                                var ret = _event_hook_map_for3rd[msgWrap[_EVENT_ID]](msgWrap['__params']);
                                return JSON.stringify(ret);
                            } else if (typeof _event_hook_map[msgWrap[_EVENT_ID]] === 'function') {;
                                var ret = _event_hook_map[msgWrap[_EVENT_ID]](msgWrap['__params']);
                                _setResultValue('SCENE_HANDLEMSGFROMFRWEB', JSON.stringify(ret));
                                return JSON.stringify(ret);
                            }
                      }
                      _setResultValue('SCENE_HANDLEMSGFROMFRWEB', JSON.stringify({'__err_code':'ev404'}));
                      return JSON.stringify({'__err_code':'ev404'});
                    }
                    break;
            }
        }

        /*
         * 对IFrame的src属性的变更，客户端有可能还没有收到前一次，就被后一次覆盖，
         * 因此添加一个队列处理这种情况，在收到客户端确认后，再处理下一次
         */
        var _setResultQueue = [];
        var _setResultQueueRunning = false;

        function _setResultValue(scene, result) {
            if (result === undefined) {
                result = 'dummy';
            }
            //_setResultQueue.push(scene + '&' + base64encode(UTF8.encode(result)));
            _setResultQueue.push(scene + '&' + result);
            if (!_setResultQueueRunning) {
                _continueSetResult();
            }
        }

        function _continueSetResult() {
            var result = _setResultQueue.shift();
            if (result === undefined) {
                _setResultQueueRunning = false;
            } else {
                 if (window.FRWebJSBridge._isBridgeByIframe){
                    _setResultQueueRunning = true;
                    _setResultIframe.src = 'frweb://private/setresult/' + result;
                 } else {
                    _setResultQueueRunning = true;
                    console.log('frweb://private/setresult/' + result);
                 }
            }
        }

        function _call(func,params,callback) {
            var curFuncIdentifier = __FRWebJSBridge.call;
            if (curFuncIdentifier !== _callIdentifier) {
                return;
            }
            if (!func || typeof func !== 'string') {
                return;
            };
            if (typeof params !== 'object') {
                params = {};
            };

            var callbackID = (_callback_count++).toString();

            if (typeof callback === 'function') {
                _callback_map[callbackID] = callback;
            };

            var msgObj = {'func':func,'params':params};
            msgObj[_MESSAGE_TYPE] = 'call';
            msgObj[_CALLBACK_ID] = callbackID;

            _sendMessage(JSON.stringify(msgObj));
        }

        function _on(event, callback) {
            if (!event || typeof event !== 'string') {
                return;
            };
            if (typeof callback !== 'function') {
                return;
            };
              _event_hook_map[event] = callback;
        }

        function _onfor3rd(event, callback) {
            if (!event || typeof event !== 'string') {
                return;
            }
            if (typeof callback !== 'function') {
            return;
            }
            _event_hook_map_for3rd[event] = callback;
        }

        function _setDefaultEventHandlers() {
            // the first event
            _on('sys:init',function(ses){
                /* 避免由于Java层多次发起init请求，造成网页端多次收到WeixinJSBridgeReady事件 */
                if (window.FRWebJSBridge._hasInit) {
                    //_log('hasInit, no need to init again');
                    return;
                }

                window.FRWebJSBridge._hasInit = true;

                if (!window.FRWebJSBridge._hasPreInit) {
                    //console.log("weixin://preInjectJSBridge/fail");
                    //_session_data = ses;
                } else {
                   //console.log("weixin://preInjectJSBridge/ok");
                }
                // bridge ready
                var readyEvent = doc.createEvent('Events');
                readyEvent.initEvent('FRWebJSBridgeReady');
                doc.dispatchEvent(readyEvent);
            });
            // event
            _on('event:deviceready', function(ses) {
                var ev = doc.createEvent('Events');
                ev.initEvent('deviceready');
                doc.dispatchEvent(ev);
            });
            _on('event:pause', function(ses) {
                var ev = doc.createEvent('Events');
                ev.initEvent('pause');
                doc.dispatchEvent(ev);
            });
            _on('event:resume', function(ses) {
                var ev = doc.createEvent('Events');
                ev.initEvent('resume');
                doc.dispatchEvent(ev);
            });
            _on('event:backbutton', function(ses) {
                var ev = doc.createEvent('Events');
                ev.initEvent('backbutton');
                doc.dispatchEvent(ev);
            });
        }

        var __FRWebJSBridge = {
            // public
            invoke: _call,
            call: _call,
            on: _onfor3rd,
            // private
            _fetchQueue: _fetchQueue,
            _hasInit: false,
            _hasPreInit: false,
            _isBridgeByIframe:true,
            _continueSetResult: _continueSetResult
        };

        try {
            Object.defineProperty(__FRWebJSBridge, '_handleMessageFromFRWeb', {
                value: _handleMessageFromFRWeb,
                writable: false,
                configurable: false
            });
        } catch(e) {
            return;
        }

        try {
            Object.defineProperty(window, 'FRWebJSBridge', {
                value: __FRWebJSBridge,
                writable: false,
                configurable: false
            });
        } catch(e) {
            return;  /* 如果页面已经存在 FRWebJSBridge，是恶意页面，就直接 return */
        }

        var doc = document;
        _createQueueReadyIframe(doc);
        _setDefaultEventHandlers();

        // Event Intercept
        var m_document_addEventListener = document.addEventListener;
        var m_document_removeEventListener = document.removeEventListener;
        var m_window_addEventListener = window.addEventListener;
        var m_window_removeEventListener = window.removeEventListener;

        var documentEventHandlers = {};
        var windowEventHandlers = {};

        document.addEventListener = function (evt, handler, capture) {
            var e = evt.toLowerCase();
            if (typeof documentEventHandlers[e] !== 'undefined') {
                documentEventHandlers[e].subscribe(handler);
            } else {
                m_document_addEventListener.call(document, evt, handler, capture);
            }
        };

        window.addEventListener = function (evt, handler, capture) {
            var e = evt.toLowerCase();
            if (typeof windowEventHandlers[e] !== 'undefined') {
                windowEventHandlers[e].subscribe(handler);
            } else {
                m_window_addEventListener.call(window, evt, handler, capture);
            }
        };

        document.removeEventListener = function (evt, handler, capture) {
            var e = evt.toLowerCase();
            // If unsubscribing from an event that is handled by a plugin
            if (typeof documentEventHandlers[e] !== 'undefined') {
                documentEventHandlers[e].unsubscribe(handler);
            } else {
                m_document_removeEventListener.call(document, evt, handler, capture);
            }
        };

        window.removeEventListener = function (evt, handler, capture) {
            var e = evt.toLowerCase();
            // If unsubscribing from an event that is handled by a plugin
            if (typeof windowEventHandlers[e] !== 'undefined') {
                windowEventHandlers[e].unsubscribe(handler);
            } else {
                m_window_removeEventListener.call(window, evt, handler, capture);
            }
        };

        var frwebAddEventListener = document.addEventListener;

        document.addEventListener = function (evt, handler, capture) {
            var e = evt.toLowerCase();
            if (e == "backbutton") {
                if (window.FRWebJSBridge) {
                    FRWebJSBridge.invoke("overrideBackbutton", {}, function(data) {
                    });
                }
            }
            frwebAddEventListener(evt, handler, capture);

            //if (evt === 'resume' && lastResumeEvent) {
            //    handler(lastResumeEvent);
            //}
        };
})();